/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.AllowedPolicyValue;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class AllowedPolicyValueFacade extends AbstractFacade<AllowedPolicyValue>
{
    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public AllowedPolicyValueFacade() {
        super(AllowedPolicyValue.class);
    }
    
    public AllowedPolicyValue findByName(String name) {
        try {
            return (AllowedPolicyValue) em.createNamedQuery("AllowedPolicyValue.findByPolicyValue")
                    .setParameter("policyValue", name)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

    public AllowedPolicyValue findById(int id) {
        try {
            return (AllowedPolicyValue) em.createNamedQuery("AllowedPolicyValue.findById")
                    .setParameter("id", id)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

    public List<AllowedPolicyValue> findByPolicyPropertyId(int id) {
        try {
            return (List<AllowedPolicyValue>) em.createNamedQuery("AllowedPolicyValue.findByPolicyPropertyId")
                    .setParameter("policyPropertyId", id)
                    .getResultList();
        } catch (NoResultException ex) {
        }
        return null;
    }

}
