/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "data_folder")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "DataFolder.findAll", query = "SELECT d FROM DataFolder d"),
    @NamedQuery(name = "DataFolder.findById", query = "SELECT d FROM DataFolder d WHERE d.id = :id"),
    @NamedQuery(name = "DataFolder.findByDataPath", query = "SELECT d FROM DataFolder d WHERE d.dataPath = :dataPath"),
    @NamedQuery(name = "DataFolder.findByDescription", query = "SELECT d FROM DataFolder d WHERE d.description = :description")})
public class DataFolder extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 1024)
    @Column(name = "data_path")
    private String dataPath;
    @Size(max = 256)
    @Column(name = "description")
    private String description;
    @JoinTable(name = "experiment_data_folder", joinColumns = {
        @JoinColumn(name = "data_folder_id", referencedColumnName = "id")}, inverseJoinColumns = {
        @JoinColumn(name = "experiment_id", referencedColumnName = "id")})
    @ManyToMany
    private List<Experiment> experimentList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "dataFolder")
    private List<DataFolderPermission> dataFolderPermissionList;
    @OneToMany(mappedBy = "parentDataFolder")
    private List<DataFolder> dataFolderList;
    @JoinColumn(name = "parent_data_folder_id", referencedColumnName = "id")
    @ManyToOne
    private DataFolder parentDataFolder;

    public DataFolder() {
    }

    public DataFolder(Integer id) {
        this.id = id;
    }

    public DataFolder(Integer id, String path) {
        this.id = id;
        this.dataPath = path;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getDataPath() {
        return dataPath;
    }

    public void setDataPath(String dataPath) {
        this.dataPath = dataPath;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<Experiment> getExperimentList() {
        return experimentList;
    }

    public void setExperimentList(List<Experiment> experimentList) {
        this.experimentList = experimentList;
    }

    @XmlTransient
    public List<DataFolderPermission> getDataFolderPermissionList() {
        return dataFolderPermissionList;
    }

    public void setDataFolderPermissionList(List<DataFolderPermission> dataFolderPermissionList) {
        this.dataFolderPermissionList = dataFolderPermissionList;
    }

    @XmlTransient
    public List<DataFolder> getDataFolderList() {
        return dataFolderList;
    }

    public void setDataFolderList(List<DataFolder> dataFolderList) {
        this.dataFolderList = dataFolderList;
    }

    public DataFolder getParentDataFolder() {
        return parentDataFolder;
    }

    public void setParentDataFolder(DataFolder parentDataFolder) {
        this.parentDataFolder = parentDataFolder;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DataFolder)) {
            return false;
        }
        DataFolder other = (DataFolder) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.DataFolder[ id=" + id + " ]";
    }
    
}
