/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "data_folder_permission")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "DataFolderPermission.findAll", query = "SELECT d FROM DataFolderPermission d"),
    @NamedQuery(name = "DataFolderPermission.findById", query = "SELECT d FROM DataFolderPermission d WHERE d.id = :id"),
    @NamedQuery(name = "DataFolderPermission.findByPermissionValue", query = "SELECT d FROM DataFolderPermission d WHERE d.permissionValue = :permissionValue"),
    @NamedQuery(name = "DataFolderPermission.findByDescription", query = "SELECT d FROM DataFolderPermission d WHERE d.description = :description")})
public class DataFolderPermission extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(max = 256)
    @Column(name = "permission_value")
    private String permissionValue;
    @Size(max = 256)
    @Column(name = "description")
    private String description;
    @JoinColumn(name = "data_folder_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private DataFolder dataFolder;

    public DataFolderPermission() {
    }

    public DataFolderPermission(Integer id) {
        this.id = id;
    }

    public DataFolderPermission(Integer id, String value) {
        this.id = id;
        this.permissionValue = value;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getPermissionValue() {
        return permissionValue;
    }

    public void setPermissionValue(String permissionValue) {
        this.permissionValue = permissionValue;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public DataFolder getDataFolder() {
        return dataFolder;
    }

    public void setDataFolder(DataFolder dataFolder) {
        this.dataFolder = dataFolder;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DataFolderPermission)) {
            return false;
        }
        DataFolderPermission other = (DataFolderPermission) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.DataFolderPermission[ id=" + id + " ]";
    }
    
}
