/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Experiment.findAll", query = "SELECT e FROM Experiment e"),
    @NamedQuery(name = "Experiment.findById", query = "SELECT e FROM Experiment e WHERE e.id = :id"),
    @NamedQuery(name = "Experiment.findByName", query = "SELECT e FROM Experiment e WHERE e.name = :name"),
    @NamedQuery(name = "Experiment.findByDescription", query = "SELECT e FROM Experiment e WHERE e.description = :description"),
    @NamedQuery(name = "Experiment.findByStartDate", query = "SELECT e FROM Experiment e WHERE e.startDate = :startDate"),
    @NamedQuery(name = "Experiment.findByEndDate", query = "SELECT e FROM Experiment e WHERE e.endDate = :endDate")})
public class Experiment extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(max = 64)
    @Column(name = "name")
    private String name;
    @Size(max = 2000)
    @Column(name = "description")
    private String description;
    @Column(name = "start_date", columnDefinition="TIMESTAMP WITH TIME ZONE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date startDate;
    @Column(name = "end_date", columnDefinition="TIMESTAMP WITH TIME ZONE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date endDate;
    @ManyToMany(mappedBy = "experimentList")
    private List<DataFolder> dataFolderList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "experiment")
    private List<UserExperimentRole> userExperimentRoleList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "experiment")
    private List<ExperimentPolicy> experimentPolicyList;
    @JoinColumn(name = "experiment_type_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private ExperimentType experimentType;

    public Experiment() {
    }

    public Experiment(Integer id) {
        this.id = id;
    }

    public Experiment(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

   public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    @XmlTransient
    public List<DataFolder> getDataFolderList() {
        return dataFolderList;
    }

    public void setDataFolderList(List<DataFolder> dataFolderList) {
        this.dataFolderList = dataFolderList;
    }

    @XmlTransient
    public List<UserExperimentRole> getUserExperimentRoleList() {
        return userExperimentRoleList;
    }

    public void setUserExperimentRoleList(List<UserExperimentRole> userExperimentRoleList) {
        this.userExperimentRoleList = userExperimentRoleList;
    }

    @XmlTransient
    public List<ExperimentPolicy> getExperimentPolicyList() {
        return experimentPolicyList;
    }

    public void setExperimentPolicyList(List<ExperimentPolicy> experimentPolicyList) {
        this.experimentPolicyList = experimentPolicyList;
    }

    public ExperimentType getExperimentType() {
        return experimentType;
    }

    public void setExperimentType(ExperimentType experimentType) {
        this.experimentType = experimentType;
    }
    
    public ExperimentPolicy getPolicyForType(int typeId) {
        for (ExperimentPolicy experimentPolicy : experimentPolicyList) {
            if (experimentPolicy.getPolicyType().getId() == typeId) {
                return experimentPolicy;
            }
        }
        return null;
    }


    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Experiment)) {
            return false;
        }
        Experiment other = (Experiment) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.Experiment[ id=" + id + " ]";
    }
    
}
