/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment_policy")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentPolicy.findAll", query = "SELECT e FROM ExperimentPolicy e"),
    @NamedQuery(name = "ExperimentPolicy.findById", query = "SELECT e FROM ExperimentPolicy e WHERE e.id = :id"),
    @NamedQuery(name = "ExperimentPolicy.findByExperimentId", query = "SELECT e FROM ExperimentPolicy e WHERE e.experiment.id = :experimentId"),
    @NamedQuery(name = "ExperimentPolicy.findByPolicyTypeId", query = "SELECT e FROM ExperimentPolicy e WHERE e.policyType.id = :policyTypeId")})

public class ExperimentPolicy extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @JoinColumn(name = "policy_type_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private PolicyType policyType;
    @JoinColumn(name = "experiment_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private Experiment experiment;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "experimentPolicy")
    private List<ExperimentPolicyPropertyValue> experimentPolicyPropertyValueList;
   

    public ExperimentPolicy() {
    }

    public ExperimentPolicy(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public PolicyType getPolicyType() {
        return policyType;
    }

    public void setPolicyType(PolicyType policyType) {
        this.policyType = policyType;
    }

     public Experiment getExperiment() {
        return experiment;
    }

    public void setExperiment(Experiment experiment) {
        this.experiment = experiment;
    }

    @XmlTransient
    public List<ExperimentPolicyPropertyValue> getExperimentPolicyPropertyValueList() {
        return experimentPolicyPropertyValueList;
    }

    public void setExperimentPolicyPropertyValue(List<ExperimentPolicyPropertyValue> experimentPolicyPropertyValueList) {
        this.experimentPolicyPropertyValueList = experimentPolicyPropertyValueList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentPolicy)) {
            return false;
        }
        ExperimentPolicy other = (ExperimentPolicy) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.ExperimentPolicy[ id=" + id + " ]";
    }
    
}
