/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
/**
 *
 * @author bfrosik
 */
@Entity
@Table(name = "experiment_policy_property_value")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findAll", query = "SELECT e FROM ExperimentPolicyPropertyValue e"),
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findById", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.id = :id"),
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findByPolicyPropertyValue", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.policyPropertyValue = :policyPropertyValue"),
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findByPolicyPropertyId", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.policyProperty.id = :policyPropertyId"),
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findByExperimentPolicyId", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.experimentPolicy.id = :experimentPolicyId")})

public class ExperimentPolicyPropertyValue extends CloneableEntity 
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @Size(max = 256)
    @Column(name = "policy_property_value")
    private String policyPropertyValue;
    @Basic(optional = false)
    @NotNull
    @Size(max = 256)
    @Column(name = "modified_by")
    private String modifiedBy;
    @Basic(optional = false)
    @NotNull
    @Column(name = "modified_date")
    @Temporal(TemporalType.DATE)
    private Date modifiedDate;
    @JoinColumn(name = "policy_property_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private PolicyProperty policyProperty;
    @JoinColumn(name = "experiment_policy_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private ExperimentPolicy experimentPolicy;

    public ExperimentPolicyPropertyValue() {
    }

    public ExperimentPolicyPropertyValue(Integer id) {
        this.id = id;
    }

    public ExperimentPolicyPropertyValue(Integer id, String value) {
        this.id = id;
        this.policyPropertyValue = value;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getPolicyPropertyValue() {
        return policyPropertyValue;
    }

    public void setPolicyPropertyValue(String policyPropertyValue) {
        this.policyPropertyValue = policyPropertyValue;
    }

    public PolicyProperty getPolicyProperty() {
        return policyProperty;
    }

    public void setPolicyProperty(PolicyProperty policyProperty) {
        this.policyProperty = policyProperty;
    }

    public ExperimentPolicy getExperimentPolicy() {
        return experimentPolicy;
    }

    public void setExperimentPolicy(ExperimentPolicy experimentPolicy) {
        this.experimentPolicy = experimentPolicy;
    }
    
    public String getModifiedBy() {
        return modifiedBy;
    }

    public void setModifiedBy(String modifiedBy) {
        this.modifiedBy = modifiedBy;
    }

    public Date getModifiedDate() {
        return modifiedDate;
    }

    public void setModifiedDate(Date modifiedDate) {
        this.modifiedDate = modifiedDate;
    }
    
    public String getUnits() {
        return policyProperty.getUnits();
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentPolicyPropertyValue)) {
            return false;
        }
        ExperimentPolicyPropertyValue other = (ExperimentPolicyPropertyValue) object;
        return (this.id != null || other.id == null) && (this.id == null || this.id.equals(other.id));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.ExperimentPolicyPropertyValue[ id=" + id + " ]";
    }

}
