#!/usr/bin/env python

from dm.cat_web_service.api.fileRestApi import FileRestApi
from dm.common.exceptions.invalidRequest import InvalidRequest
from catWebServiceSessionCli import CatWebServiceSessionCli

class GetFilesCli(CatWebServiceSessionCli):
    def __init__(self):
        CatWebServiceSessionCli.__init__(self, validArgCount=self.ANY_NUMBER_OF_POSITIONAL_ARGS)

    def checkArgs(self):
        pass

    def runCommand(self):
        self.parseArgs(usage="""
    dm-get-files 
        [key1:value1, key2:value2, ...]

Description:
    Retrieve files from the metadata catalog. Only those files that
    match provided key/value metadata pairs will be returned. If no specific
    metadata key/values are requested, all experiment files will be returned. 
        """)
        self.checkArgs()
        api = FileRestApi(self.getLoginUsername(), self.getLoginPassword(), self.getServiceHost(), self.getServicePort(), self.getServiceProtocol())
        queryDict = self.splitArgsIntoDict()
        fileMetadataList = api.getFiles(queryDict)
        for fileMetadata in fileMetadataList:
            print fileMetadata.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())

#######################################################################
# Run command.
if __name__ == '__main__':
    cli = GetFilesCli()
    cli.run()

