#!/usr/bin/env python

from dm.common.utility.loggingManager import LoggingManager
from dm.common.exceptions.invalidArgument import InvalidArgument
from dm.common.exceptions.objectAlreadyExists import ObjectAlreadyExists
from dm.common.exceptions.objectNotFound import ObjectNotFound
from dm.common.exceptions.dbError import DbError
from dmMongoCollection import DmMongoCollection

class FileCollection(DmMongoCollection):
    """Class responsible for updating file collection in mongo db."""

    UNIQUE_KEYS_LIST = [ '_fileName', '_experimentName' ]

    def __init__(self, dbClient):
        DmMongoCollection.__init__(self, 'files', dbClient)

#######################################################################
# Testing
if __name__ == '__main__':
    from dmMongoClient import DmMongoClient
    mongo = DmMongoClient('dm')
    fileCollection = FileCollection(mongo)
    fileInfo = {'_fileName' : 'xyz-001', '_experimentName' : 'myexp-001', 'update' : 'sv2', 'locationList' : '[/opt/xyz, /data/xyz]'}
    print fileCollection.updateByUniqueKeys(fileInfo)
    #print type(fileCollection.findByName('xyz-001'))
    print fileCollection.findByQueryDict({'experiment' : 'exp-001'}, {'locationList' : 1})
    fileInfo['_experimentName'] = 'ddm1'
    print fileCollection.addByUniqueKeys(fileInfo)



