#!/usr/bin/env python

#
# User route descriptor.
#

from dm.common.utility.configurationManager import ConfigurationManager
from experimentSessionController import ExperimentSessionController

class ExperimentRouteDescriptor:

    @classmethod
    def getRoutes(cls):
        contextRoot = ConfigurationManager.getInstance().getContextRoot()

        # Static instances shared between different routes
        experimentSessionController = ExperimentSessionController()

        # Define routes.
        routes = [

            # Start experiment daq
            {
                'name' : 'startDaq',
                'path' : '%s/experiments/startDaq' % contextRoot,
                'controller' : experimentSessionController,
                'action' : 'startDaq',
                'method' : ['POST']
            },

            # Stop experiment daq
            {
                'name' : 'stopDaq',
                'path' : '%s/experiments/stopDaq' % contextRoot,
                'controller' : experimentSessionController,
                'action' : 'stopDaq',
                'method' : ['POST']
            },

            # Upload experiment data 
            {
                'name' : 'upload',
                'path' : '%s/experiments/upload' % contextRoot,
                'controller' : experimentSessionController,
                'action' : 'upload',
                'method' : ['POST']
            },

        ]
       
        return routes


