#!/usr/bin/env python

from dm.common.cli.dmRestSessionCli import DmRestSessionCli
from dm.common.utility.osUtility import OsUtility
from dm.common.utility.configurationManager import ConfigurationManager

class DsWebServiceSessionCli(DmRestSessionCli):
    """ DM DS web service session cli class. """

    DEFAULT_SESSION_CACHE_FILE = OsUtility.getUserHomeDir() + '/.dm/.ds.session.cache'

    def __init__(self, validArgCount=0):
        DmRestSessionCli.__init__(self, validArgCount)
        ConfigurationManager.getInstance().setSessionCacheFile(DsWebServiceSessionCli.DEFAULT_SESSION_CACHE_FILE)

    def getDefaultServiceHost(self):
        return ConfigurationManager.getInstance().getDsWebServiceHost()

    def getDefaultServicePort(self):
        return ConfigurationManager.getInstance().getDsWebServicePort()

