#!/usr/bin/env python

from dm.ds_web_service.api.experimentRestApi import ExperimentRestApi
from dm.common.exceptions.invalidRequest import InvalidRequest
from dsWebServiceSessionCli import DsWebServiceSessionCli

class StopExperimentCli(DsWebServiceSessionCli):
    def __init__(self):
        DsWebServiceSessionCli.__init__(self)
        self.addOption('', '--name', dest='name', help='Experiment name.')

    def checkArgs(self):
        if self.options.name is None:
            raise InvalidRequest('Experiment name must be provided.')

    def getName(self):
        return self.options.name

    def runCommand(self):
        self.parseArgs(usage="""
    dm-stop-experiment --name=NAME

Description:
    Updates experiment end date in the DM database and checks experiment data permissions.
        """)
        self.checkArgs()
        api = ExperimentRestApi(self.getLoginUsername(), self.getLoginPassword(), self.getServiceHost(), self.getServicePort(), self.getServiceProtocol())
        experiment = api.stopExperiment(self.getName())
        print experiment.getDisplayString(self.getDisplayKeys(), self.getDisplayFormat())

#######################################################################
# Run command.
if __name__ == '__main__':
    cli = StopExperimentCli()
    cli.run()

