#!/usr/bin/env python

from dm.common.constants import dmRole
from dm.common.objects.authorizationPrincipal import AuthorizationPrincipal
from dm.common.db.api.userDbApi import UserDbApi
from dm.common.service.auth.authorizationPrincipalRetriever import AuthorizationPrincipalRetriever 
from dm.ds_web_service.api.dsRestApiFactory import DsRestApiFactory


class DsAuthPrincipalRetriever(AuthorizationPrincipalRetriever):

    def __init__(self):
        AuthorizationPrincipalRetriever.__init__(self, self.__class__.__name__)
        self.authApi = DsRestApiFactory.getAuthRestApi()

    def getAuthorizationPrincipal(self, username):
        principal = self.authApi.getAuthorizationPrincipal(username)
        return principal

#######################################################################
# Testing.
if __name__ == '__main__':
    pass

