#!/usr/bin/env python

#
# Auth route descriptor.
#

from dm.common.utility.configurationManager import ConfigurationManager
from authSessionController import AuthSessionController

class AuthRouteDescriptor:

    @classmethod
    def getRoutes(cls):
        contextRoot = ConfigurationManager.getInstance().getContextRoot()
        authSessionController = AuthSessionController()

        routes = [

            # Get authorization principal
            {
                'name'          : 'getAuthorizationPrincipal',
                'path'          : '%s/authorizationPrincipals/:(username)' % contextRoot,
                'controller'    : authSessionController,
                'action'        : 'getAuthorizationPrincipal',
                'method'        : [ 'GET' ]
            },

        ]
       
        return routes


