#authenticateUser!/usr/bin/env python

import cherrypy
from dm.common.service.dmSessionController import DmSessionController
from dm.ds_web_service.service.impl.authSessionControllerImpl import AuthSessionControllerImpl

class AuthSessionController(DmSessionController):

    def __init__(self):
        DmSessionController.__init__(self)
        self.authSessionControllerImpl = AuthSessionControllerImpl()

    @cherrypy.expose
    @DmSessionController.require(DmSessionController.isAdministrator())
    @DmSessionController.execute
    def getAuthorizationPrincipal(self, username, **kwargs):
        if not len(username):
            raise InvalidRequest('Invalid username provided.')
        response = self.authSessionControllerImpl.getAuthorizationPrincipal(username).getFullJsonRep()
        self.logger.debug('Returning authorization principal for %s' % (username))
        return response

