#!/usr/bin/env python

#
# Implementation for user info controller.
#

from dm.common.constants import dmRole
from dm.common.objects.authorizationPrincipal import AuthorizationPrincipal 
from dm.common.objects.dmObjectManager import DmObjectManager
from dm.common.db.api.userDbApi import UserDbApi

class AuthSessionControllerImpl(DmObjectManager):
    """ User info controller implementation class. """

    def __init__(self):
        DmObjectManager.__init__(self)
        self.userDbApi = UserDbApi()

    def getAuthorizationPrincipal(self, username):
        user = self.userDbApi.getUserWithPasswordByUsername(username)
        principal = AuthorizationPrincipal(name=username, token=user.get('password'))
        principal.setRole(dmRole.DM_USER_ROLE)
        principal.setUserInfo(user)
        for userSystemRoleName in user.get('userSystemRoleNameList', []):
            if userSystemRoleName == dmRole.DM_ADMIN_ROLE:
                principal.setRole(dmRole.DM_ADMIN_ROLE)
        return principal


