package gov.anl.aps.dm.sync;

import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

public class OracleConnection {
    Connection connection = null;
    private Logger logger;

    public OracleConnection(Logger logger) {
    	this.logger = logger;
    }
    
    void connect(Properties config) throws SQLException {
        try {
            DriverManager.registerDriver(new oracle.jdbc.OracleDriver());

        } catch (SQLException e) {
            logger.log(Level.SEVERE, "Can't establish Oracle Driver", e);
            throw e;
        }
//        logger.log(Level.INFO, "Oracle JDBC Driver Registered!");

        try {
            connection = DriverManager.getConnection(
                    config.getProperty("oracle.database.connection"),
                    config.getProperty("oracle.database.username"),
                    config.getProperty("oracle.database.password"));
        } catch (SQLException e) {
            logger.log(Level.SEVERE, "Can't connect to Oracle data base", e);
            throw e;
        }        
    }
    
    ResultSet getUsers(String table) throws SQLException {
        try {
            Statement statement = connection.createStatement();
            return statement.executeQuery("select * from " + table);
        } catch (SQLException ex) {
            logger.log(Level.SEVERE, "table {0} does not exist", table);
            throw ex;
        }
    }
    
    void close() {
        try {
            connection.close();
        } catch (SQLException ex) {
            logger.log(Level.SEVERE, "problem closing Oracle connection ", ex);
        }
    }
}
